#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

import sys, os, os.path, getopt, fnmatch
from checkutils import *

from qttable import QTable, QTableItem

class tableitem(QTableItem):
    def __init__(self, table, data):
        QTableItem.__init__(self, table, QTableItem.OnTyping, str(data))
        self.setWordWrap(True)
#setCellWidget (Ktetxtedt) -> für diff highlight?

class diffdictobjekt():
    def __init__(self):
        self.dict={}
    def ad_msgstr(self,msgid,po,nr):
        if self.dict.has_key(msgid):
            l=self.dict[msgid]
            l2=[po,nr,po.msgstr[nr],po.is_fuzzy(nr)]
            l.append(l2)
            self.dict[msgid]=l
        else:
            self.dict[msgid]=[[po,nr,po.msgstr[nr],po.is_fuzzy(nr)]]
    def change_msgstr(self, msgid, listnr, msg):
        liste=self.dict[msgid]
        liste[listnr][2]=msg
        liste[listnr][3]=False #fuzzy off
        self.dict[msgid]=liste
    def toggle_fuzzy(self, msgid, listnr):
        liste=self.dict[msgid]
        liste[listnr][3]=not liste[listnr][3]
        self.dict[msgid]=liste
    def revert(self, msgid, listnr):
        liste=self.dict[msgid]
        liste[listnr][2]=liste[listnr][0].msgstr[liste[listnr][1]]
        liste[listnr][3]=liste[listnr][0].is_fuzzy(liste[listnr][1])
        self.dict[msgid]=liste

class MessageDialog(QDialog):
    def __init__(self, parent=None, diffdict=None, title=None):
        self.desktopfilestrings=["Name=", "Comment=", "GenericName="] #kde3
        self.msglist=diffdict.dict.keys()
        self.msglist.sort()
        self.diffdict= diffdict
        #msglist=[u'msgstr0',u'msgstr1',...]
        #diffdict={u"msgstr0": [[po, msgnr,msgstr,fuzzy], [po, msgnr,msgstr,fuzzy]], u"msgstr1": [[po,,...}
        self.nr, self.maxnr=0, len(self.msglist)-1
        QDialog.__init__(self, parent)
        self.setCaption(title)
        self.nolabel= QLabel('msgid x of y messages',self)
        self.translabel= QLabel('x translations',self)
        self.msgid = KTextEdit('msgid', '', self)
        self.msgid.setTextFormat(Qt.PlainText)
        self.msgid.setReadOnly (True)
        self.msgid.setMaximumHeight(100)
        self.msgtable=QTable(2,6,self)
        self.msgtable.setColumnReadOnly(0,True) 
        self.msgtable.setColumnReadOnly(3,True) 
        self.msgtable.setColumnReadOnly(4,True) 
        self.msgtable.setColumnReadOnly(5,True) 
        self.msgtable.setShowGrid(False)
#	self.msgtable.setFocusStyle(QTable.FollowStyle)
        self.msgtable.setSelectionMode(QTable.SingleRow)
        header = self.msgtable.horizontalHeader()
        header.setLabel(0, "message catalog")
        header.setLabel(1, "msgstr")
        header.setLabel(2, "msgstr[1]")
        header.setLabel(3, "msgctxt")
        header.setLabel(4, "status")
        header.setLabel(5, "mod.")
        self.prevbutton = KPushButton('<',self)
        self.prevbutton.setAccel(Qt.Key_Prior)
        tooltip = QToolTip.add(self.prevbutton,'Goto previous msgid (Page Up)')
        self.nextbutton = KPushButton('>', self)
        self.nextbutton.setAccel(Qt.Key_Next)
        tooltip = QToolTip.add(self.nextbutton,'Goto next msgid (Page Down)')
        self.firstbutton = KPushButton('<<', self)
        self.firstbutton.setAccel(Qt.Key_Home)
        tooltip = QToolTip.add(self.firstbutton,'Goto first msgid (Home)')
        self.lastbutton = KPushButton('>>', self)
        self.lastbutton.setAccel(Qt.Key_End)
        tooltip = QToolTip.add(self.lastbutton,'Goto last msgid (End)')
        self.alltocurrentbutton = KPushButton('&All to Current', self)
        tooltip = QToolTip.add(self.alltocurrentbutton,'Set all msgstr to current msgstr')
        self.emptytocurrentbutton = KPushButton('&Empty to Current', self)
        tooltip = QToolTip.add(self.emptytocurrentbutton,'Set empty msgstr to current msgstr')
        self.closebutton = KPushButton('&Close', self)
        tooltip = QToolTip.add(self.closebutton,'Close and save all changed messages')
        self.quitbutton = KPushButton('&Quit', self)
        tooltip = QToolTip.add(self.quitbutton,'Quit and discard all changed messages')
        self.revertbutton = KPushButton('&Revert', self)
        tooltip = QToolTip.add(self.revertbutton,'revert all changes to recent message (not implemented)')
        self.fuzzybutton = KPushButton('Fuzzy', self)
        #self.fuzzybutton.setAccel(Qt.CTRL+Qt.Key_U) geht nicht - automatisch &Fuzzy gesetzt
        tooltip = QToolTip.add(self.fuzzybutton,'Toggle fuzzy status (not implemented)')#(Ctrl+U)')

        layout = QVBoxLayout(self, 8)
        layout.addWidget(self.nolabel)
        layout.addWidget(self.translabel)
        layout.addWidget(QLabel('msgid:',self))
        layout.addWidget(self.msgid)
        layout.addWidget(self.msgtable)
        buttonlayout = QHBoxLayout(layout, 4)
        buttonlayout.addWidget(self.prevbutton)
        buttonlayout.addWidget(self.nextbutton)
        buttonlayout.addWidget(self.alltocurrentbutton)
        buttonlayout.addWidget(self.fuzzybutton)
        buttonlayout.addWidget(self.closebutton)
        button2layout = QHBoxLayout(layout, 4)
        button2layout.addWidget(self.firstbutton)
        button2layout.addWidget(self.lastbutton)
        button2layout.addWidget(self.emptytocurrentbutton)
        button2layout.addWidget(self.revertbutton)
        button2layout.addWidget(self.quitbutton)
        self.connect(self.prevbutton, SIGNAL('clicked()'), self.previd)
        self.connect(self.nextbutton, SIGNAL('clicked()'), self.nextid)
        self.connect(self.firstbutton, SIGNAL('clicked()'), self.firstid)
        self.connect(self.lastbutton, SIGNAL('clicked()'), self.lastid)
        self.connect(self.alltocurrentbutton, SIGNAL('clicked()'), self.setalltocurrent)
        self.connect(self.emptytocurrentbutton, SIGNAL('clicked()'), self.setemptytocurrent)
        self.connect(self.closebutton, SIGNAL('clicked()'), self,SLOT('accept()'))
        self.connect(self.quitbutton, SIGNAL('clicked()'), self,SLOT('reject()'))
        self.connect(self.revertbutton, SIGNAL('clicked()'), self.revertchanges)
        self.connect(self.fuzzybutton, SIGNAL('clicked()'), self.togglefuzzy)
        self.connect(self.msgtable, SIGNAL('valueChanged(int,int)'), self.set_msgstrpo)
        self.connect(self.msgtable, SIGNAL('currentChanged(int,int)'), self.currentchanged)
        self.setdata()
    def currentchanged(self):
        isplural=self.msgtable.isColumnHidden(2)==False
        emptymsgstr=False
        self.alltocurrentbutton.setEnabled(False)
        for r in range (0,self.msgtable.numRows()):
            if unicode(self.msgtable.text(r,1))=='' or (isplural and unicode(self.msgtable.text(r,2))==''):  #plural handling
                emptymsgstr=True
            if self.msgtable.text(r,1)!=self.msgtable.text(1,1) or self.msgtable.text(r,2)!=self.msgtable.text(1,2):
                self.alltocurrentbutton.setEnabled(True)
        self.emptytocurrentbutton.setEnabled(False)
        if self.msgtable.currentColumn()<1 or self.msgtable.currentColumn()>2:
            self.msgtable.setCurrentCell(self.msgtable.currentRow(),1)
        if unicode(self.msgtable.text(self.msgtable.currentRow(),1))==''\
        or (isplural and unicode (self.msgtable.text(self.msgtable.currentRow(),2))==''): #plural handling
            self.alltocurrentbutton.setEnabled(False)
        else:
            if emptymsgstr: 
                self.emptytocurrentbutton.setEnabled(True)
        r=self.msgtable.currentRow()
        i=self.ms[r]
        enable=i[0].is_fuzzy(i[1])!=i[3]
        if i[0].is_plural(i[1]):
            enable=enable or unicode(self.msgtable.text(r,1))!=i[0].msgstr[i[1]][0] or unicode(self.msgtable.text(r,2))!=i[0].msgstr[i[1]][1]
        else:
            enable=enable or unicode(self.msgtable.text(r,1))!=i[0].msgstr[i[1]]
        self.revertbutton.setEnabled(enable)
        self.fuzzybutton.setEnabled(True)
        if isplural:
            if unicode(self.msgtable.text(r,1))=='' and unicode(self.msgtable.text(r,2))=='':self.fuzzybutton.setEnabled(False)
        else: 
            if unicode(self.msgtable.text(r,1))=='':self.fuzzybutton.setEnabled(False)
    def previd(self):
        if self.nr>0:
            self.nr-=1
            self.setdata()
    def nextid(self):
        if self.nr<self.maxnr:
            self.nr+=1
            self.setdata()
    def firstid(self):
        self.nr=0
        self.setdata()
    def lastid(self):
        self.nr=self.maxnr
        self.setdata()
    def setalltocurrent(self):
        if self.ms[self.msgtable.currentRow()][0].is_desktop_file():
            print "not implemented for kde3 desktop_*.po's"
        else:
            m=unicode(self.msgtable.text(self.msgtable.currentRow(),1))
            m2=unicode(self.msgtable.text(self.msgtable.currentRow(),2)) #plural 
            for r in range (0,self.msgtable.numRows()):
                self.msgtable.setText(r,1,m)
                self.msgtable.setText(r,2,m2) #plural
                self.set_msgstrpo(r)
            self.alltocurrentbutton.setEnabled(False)
#           alle cataloge + nr aus dict raus ??
    def setemptytocurrent(self):
        if self.ms[self.msgtable.currentRow()][0].is_desktop_file():
            print "not implemented for kde3 desktop_*.po's"
        else:
            isplural=self.msgtable.isColumnHidden(2)==False
            m=self.msgtable.text(self.msgtable.currentRow(),1)
            m2=self.msgtable.text(self.msgtable.currentRow(),2)
            for r in range (0,self.msgtable.numRows()):
                if isplural:
                    if unicode(self.msgtable.text(r,1))=="" or unicode(self.msgtable.text(r,2))=='':
                        self.msgtable.setText(r,1,m)
                        self.msgtable.setText(r,2,m2)
                        self.set_msgstrpo(r)
                else:
                    if unicode(self.msgtable.text(r,1))=="": 
                        self.msgtable.setText(r,1,m)
                        self.set_msgstrpo(r)
    def revertchanges(self):
        self.diffdict.revert(self.msglist[self.nr], self.msgtable.currentRow())
        self.setdata()
    def togglefuzzy(self):
        self.diffdict.toggle_fuzzy(self.msglist[self.nr], self.msgtable.currentRow())
        self.setdata()
    def accept(self):
#        self.set_msgstrpo(self.msgtable.currentRow()) geht nicht? warum?
        for i in self.msglist:
            ms=self.diffdict.dict[i]
            for k in ms:
                if k[0].is_plural(k[1]):
                    k[0].set_msgstr(k[1], k[2])
                else:
                    k[0].set_msgstr(k[1], k[2])
                if k[0].is_fuzzy(k[1])!=k[3]:
                    k[0].set_fuzzy(k[1])
        QDialog.accept(self)
    def setdata(self):
        self.msgtable.hideColumn(2)
        self.nolabel.setText("msgid no %d of %d groups with equal msgids" %(self.nr+1,self.maxnr+1))
        k=self.msglist[self.nr]
        self.ms=self.diffdict.dict[k]
        self.maxstrnr=len(self.ms)-1
        self.translabel.setText("%d messages with different translations" %(self.maxstrnr+1))
        self.msgid.setText(self.msglist[self.nr].replace('_plural ','\n')) #plural
        r=0
        self.msgtable.setNumRows(len(self.ms))
        for i in self.ms:
            self.msgtable.setText(r,0,'%s #%d' %(i[0].name,i[1]))
            if i[0].is_plural(i[1]):
                self.msgtable.showColumn(2)
                self.msgtable.setText(r,1,i[2][0])
                self.msgtable.setText(r,2,i[2][1])
            else:
                self.msgtable.setText(r,1,i[2]) 
                self.msgtable.setText(r,2,'') 
            self.msgtable.setText(r,3,i[0].msgctxt[i[1]])
            if i[3]==True: #.is_fuzzy(i[1]):
                self.msgtable.setText(r,4,'fuzzy')
            else: self.msgtable.setText(r,4,"")
            mod=''
            if i[3]!=i[0].is_fuzzy(i[1]):
                mod='fu '
            if i[0].is_plural(i[1]):
                if i[0].msgstr[i[1]]!=[unicode(self.msgtable.text(r,1)),unicode(self.msgtable.text(r,2))]:
                    mod+='txt'
            else:
                if i[0].msgstr[i[1]]!=unicode(self.msgtable.text(r,1)):
                    mod+='txt'
            self.msgtable.setText(r,5,mod)
            r+=1
        for i in range(self.msgtable.numCols()): #besser Spaltenbreite auf Fenster verteilen / mehrzeiliges Editfenster ? 
            self.msgtable.adjustColumn(i) #qtableitem mit setWordWrap(True) ?
	self.msgtable.setColumnStretchable(1,True)
        if self.nr<self.maxnr:
            self.nextbutton.setEnabled(True)
            self.lastbutton.setEnabled(True)
        else:
            self.nextbutton.setEnabled(False)
            self.lastbutton.setEnabled(False)
        if self.nr>0:
            self.prevbutton.setEnabled(True)
            self.firstbutton.setEnabled(True)
        else:
            self.prevbutton.setEnabled(False)
            self.firstbutton.setEnabled(False)
        self.msgtable.setCurrentCell(self.msgtable.currentRow(),1)
        self.currentchanged()
    def get_msgstrtxt(self,row):
        if self.ms[row][0].is_plural(self.ms[row][1]): # plural ????
            m=[unicode(self.msgtable.text(row,1)),unicode(self.msgtable.text(row,2))]
        else: 
            m=unicode(self.msgtable.text(row,1))
        if self.ms[row][0].is_desktop_file(): # Name=, Comment= etc in desktop files 
            for i in self.desktopfilestrings:
                if m[:len(i)]==i: # == Name=, Comment= usw
                    m=m[len(i):]  # weg damit
        return m
    def set_msgstrpo(self,row):
        m=self.get_msgstrtxt(row)
        if self.ms[row][0].is_desktop_file():
            for j in self.desktopfilestrings:  #desktop_ files Name= Comment= GenericName=
                if self.ms[row][0].msgid[self.ms[row][1]][0:len(j)]==j:
                    m=j+m
        if self.ms[row][0].msgstr[self.ms[row][1]]!=m:
            print "will change %s: >%s< to >%s<" %(self.ms[row][0].name,self.ms[row][0].msgstr[self.ms[row][1]], m)
            self.diffdict.change_msgstr(self.msglist[self.nr], row, m)
	    self.setdata()
def builddiff(arg1, word_en):
    if 'l10n-kde3' in arg1: l10n,kdelibsver='l10n-kde3',''
    elif 'l10n-kde4' in arg1: l10n,kdelibsver='l10n-kde4','4'
    else: l10n,kdelibsver='l10n',''
    try:
        svndir,langmessagesmodulfilepo=arg1.split(l10n) # to find kdelibs.po/kio.po/koffice.po
        l10ndir=svndir+l10n
    except:
        l10ndir=''
    pofilelist=getfilelistfromdir(arg1,".po")
    if len(pofilelist)==0:
        print '\nNo message catalogs (*.po files) in %s\n' %arg1 
    else:
        if not only:
            if l10ndir!='':
                if '/messages/' in arg1: #nur fr gui in messages, nicht fuer doku in docmessages
                    if l10ndir+'/de/messages/kdelibs/kdelibs'+kdelibsver+'.po' not in pofilelist: 
                        pofilelist.append(l10ndir+'/de/messages/kdelibs/kdelibs'+kdelibsver+'.po') 
                    if l10ndir+'/de/messages/kdelibs/desktop_kdelibs.po' not in pofilelist: 
                        pofilelist.append(l10ndir+'/de/messages/kdelibs/desktop_kdelibs.po') 
                    if kdelibsver=='4':
                        if l10ndir+'/de/messages/kdelibs/kio'+kdelibsver+'.po' not in pofilelist: 
                            pofilelist.append(l10ndir+'/de/messages/kdelibs/kio'+kdelibsver+'.po') 
                        if l10ndir+'/de/messages/kdelibs/libphonon.po' not in pofilelist: 
                            pofilelist.append(l10ndir+'/de/messages/kdelibs/libphonon.po') 
                        if l10ndir+'/de/messages/qt/kdeqt.po' not in pofilelist: 
                            pofilelist.append(l10ndir+'/de/messages/qt/kdeqt.po') 
                    if 'koffice' in arg1 and l10ndir+'/de/messages/koffice/koffice.po' not in pofilelist:
                        pofilelist.append(l10ndir+'/de/messages/koffice/koffice.po') 
                    if 'koffice' in arg1 and l10ndir+'/de/messages/koffice/desktop_koffice.po' not in pofilelist:
                        pofilelist.append(l10ndir+'/de/messages/koffice/desktop_koffice.po') 
            else:
                print "No l10n dir and kdelibs.po/kio.po/koffice.po found"
        msgtransdict2={}   #key=msgidfilter[k] value=[[po.msgstrfilter[k],po.name,k,po.commid[k],po.msgid[k],po.msgstr[k]],[...]]
        nomessages,noallmessages=0,0
        savepolist = []
        for i in pofilelist:
            po=guidocpo(i)
	    savepolist.append(po)
            noallmessages+=len(po.msgid)
            if names:
                print '%s with %d messages' %(po.name, len(po.msgid))
            for k in po.messagerange():
                if not translated :
                    ok=True
                else:
                    ok=po.is_translated(k)
                if ok:
                    if word_en!='': ok = re.search(word_en,po.msgidfilter[k])!=None
                if po.is_translation(k) and ok:# and re.findall(word_en,po.msgidfilter[k]):
                    if len(po.msgidfilter[k])<msglen and len(po.msgidfilter[k].split())<words:
                        nomessages+=1
                        if msgtransdict2.has_key(po.msgidfilter[k]):
                            l=msgtransdict2[po.msgidfilter[k]]
                            l2=[po.msgstrfilter[k],po.name,k,po.msgctxt[k],po.msgid[k],po.msgstr[k],po]
                            l.append(l2)
                            msgtransdict2[po.msgidfilter[k]]=l
                        else:
                            msgtransdict2[po.msgidfilter[k]]=\
			    [[po.msgstrfilter[k],po.name,k,po.msgctxt[k],po.msgid[k],po.msgstr[k],po]]	
        msgidlist=msgtransdict2.keys()
        msgidlist.sort()
        if all:
            print '\nlist with all (%d) messages <%d characters and <%s words :' %(nomessages, msglen, words)
            for i in msgidlist:
                translist=msgtransdict2[i]
                for k in range(0,len(translist)):
                    if filtered:
                        print "['%s','%s','%s','%s','%s']" %(i,translist[k][0],translist[k][1],translist[k][2],translist[k][3])
                    else:
                        print "['%s','%s','%s','%s','%s']" %(translist[k][4],translist[k][5],translist[k][1],translist[k][2],translist[k][3])
        diff2,diffg=0,0
        difflist=[]
        diffdict=diffdictobjekt()
        for i in msgidlist:
            if len(msgtransdict2[i])>1:
                different=False
                translist=msgtransdict2[i]
                firsttrans=translist[0]
                for k in range(1,len(translist)):
                    msgid,msgstr=firsttrans[0],translist[k][0]
                    if upperlower:
                        msgid,msgstr=msgid.upper(),msgstr.upper()
                    if len(msgid)>1 and len(msgstr)>1:
                        if blank:
                            msgid,msgstr=msgid.strip(' '),msgstr.strip(' ')
                        if punkt:
                            msgid,msgstr=msgid.rstrip('.'),msgstr.rstrip('.')
                        if dpunkt:
                            msgid,msgstr=msgid.rstrip(':'),msgstr.rstrip(':')
                    #if klash: #filtert alles ? falsch !!!!!!!!!!!!! doesn't work as msgstrfilter in checkutils removes clashes
                    #    msgid,msgstr=firsttrans[6].message_filter(msgid),translist[k][6].message_filter(msgstr)
                    if entity:
			msgid,msgstr=entityfilter(msgid),entityfilter(msgstr)
                    if markup:
			msgid,msgstr=markupfilter(msgid),markupfilter(msgstr)
		    if levenstein>0:
                        differ=distance(msgid,msgstr)>levenstein
                    else: 
                        differ=msgid!=msgstr
                    if comment:
                        differ=differ and firsttrans[3]==translist[k][3]
                    if globally==False:
                        differ=differ and firsttrans[1]==translist[k][1] #vergleich nur dateiweise
                    if differ:
                        different=True
                if different:
                    diff2+=1
                    diffg+=len(translist)
                    for k in range(0,len(translist)):
                        if filtered:
                            difflist.append("['%s','%s','%s','%s','%s']" %(i,translist[k][0],translist[k][1],translist[k][2],translist[k][3]))
                        else:
                            difflist.append("['%s','%s','%s','%s','%s']" \
                                             %(translist[k][4],translist[k][5],translist[k][1],translist[k][2],translist[k][3]))
                        diffdict.ad_msgstr(i,translist[k][6],translist[k][2])
        if diff:
            if len(difflist)>0 and printdiff:
                print '\nlist with %d different translations of msgid' % diff2
                print "['msgid', 'msgstr', 'pofile', 'msgnr', 'comment']" 
                for i in difflist:
                    print i
        print '%d messages <%d characters and <%s words in %d files, %d with %d different translations, in %s' \
               %(nomessages, msglen, words, len(pofilelist), diff2, diffg, arg1)
        print 
        if edit and len(difflist)>0:
            from kdecore import KApplication
            from qt import SIGNAL,SLOT,QDialog
            sys.argv=sys.argv[0:1]
            app = KApplication (sys.argv,"checkdialog")
            mainWindow = MessageDialog (None,diffdict,title = "check consistent translation of messages")
            app.setMainWidget(mainWindow)
            mainWindow.resize(1024, 480)
            mainWindow.show()
#            app.connect( app, SIGNAL('lastWindowClosed()'), app, SLOT('quit()') )
            app.exec_loop()
            if mainWindow.result() == QDialog.Accepted:
                for i in savepolist:
                    i.saveclose()
                print "saved all changed message catalogues"
            else:
                print "discard all changes"

def usage():
    print '\nUsage  :  python %s [OPTION] /path/to/l10n[-kde3|4]/de/[doc]messages/[dir/[file[.po]]] [arg1]'\
                      %(os.path.basename(sys.argv[0]))
    print '          arg1 regexpression of english word in msgid'
    print '          if arg1!="": check only msgids with regexpression arg1, otherwise check all msgids'
    print 'Options: -h, --help           : usage'
    print '         -s, --summary        : print only summary'
    print '         -a, --all            : list of all messages, default only list of messages with different translations'
    print '         -m, --msglen int     : check only msgids with len<msglen characters, default msglen = %d' %msglen
    print '         -w, --words  int     : check only msgids less the int words, default words = %d' %words
    print '         -f, --filter         : print msgid+msgstr without clashes & and trailing " ..."/"..." etc'
    print '         -c, --comment        : compare msgid+msgstr+comment, default compare only msgid+msgstr'
    print '         -u, --upperlower     : compare ignoring uppercase/lowercase'
    print '         -b, --blank          : compare ignoring leading+trailing blanks'
    print '         -p, --punkt          : compare ignoring trailing "."'
    print '         -d, --dpunkt         : compare ignoring trailing ":"'
    print '         -l, --levenstein int : max levenstein distance for equality (fuzzy comparison)'
    print '         -e, --entity         : compare ignoring entities (&foo;)'
    print '         -k, --markup         : compare ignoring markup (<foo>, </foo>)'
    print '         -o, --only           : only files w/o kdelibs.po/kio.po + koffice.po (for all koffice apps), '
    print "                              : default with kdelibs.po/kio.po + koffice.po. Without effect for docmessage po's"
    #print '         -k, --klash          : compare ignoring clashes ("&"), default false'
    print '         -g, --globally       : compare only messages in one file, default in all files'
    print '         -n, --names          : print names of all pofiles, default do not print names'
    print '         -t, --translated     : check only translated messages, default all messages'
    print '         defaults             : -m %d -w %d' %(msglen, words)
    print 'Output : print sorted lists (msgid, msgstr, pofile, message-no, msgctxt) for msgids <%d characters or <%d words' %(msglen,words)
    print '         and edit messages with different translation with python-kde3-dialog'
    print
    sys.exit(2)
printdiff=False    # keine Ausgabe auf konsole
diff=True          # unterschiedliche Übersetzungen ausgeben
all = False        # keine liste aller msg,  nur diff als standard
filtered=False     # ausgabe msgid+msgstr mit '&' + '...' etc siehe checkutils.py
msglen=200          # standard max. länge der msgid
summary=False      # nicht nur zusammenfassung
comment=False      # kommentare in msgid bei vergleich ignorieren
upperlower=False   # Groß/Kleinschreibung bei vergleich nicht ignorieren
blank=False        # leerzeichen am anfang + ende bei vergleich nicht ignorieren
punkt=False        # '.' am ende bei vergleich nicht ignorieren
dpunkt=False       # ':' am ende bei vergleich nicht ignorieren
levenstein=0       # levenstein distanz
only=False         # ohne kdelibs.po (und koffice.po)
words=20           # standard max anzahl worte der msgid
#klash=False        # clash & nicht filtern
globally=True      # false: nur innerhalb einer datei vergleichen
names=False        # Namen aller pofiles ausgeben
translated=False   # true nur übersetzte nachrichten, false alle nachrichten
edit=True
entity=False       # entities filtern
markup=False        # markup filtern
word_en=''          #regexpr
try:
    opts, args = getopt.getopt(sys.argv[1:], "ham:fscubpdl:ow:kgntek", ["help", "all", "msglen=", "filter", "summary", "comment", "upperlower"\
                                             , "blank", "punkt", "dpunkt", "levenstein=", "only", "words=", "klash", "globally", "nonames"\
                                             , "translated", "entity", "markup"])
except getopt.GetoptError:
    usage() # print help information and exit

for o,a in opts:
    if o in ("-h", "--help"):
        usage()
    if o in ("-a", "--all"):
        all=True
    if o in ("-m", "--msglen"):
        msglen=int(a)
    if o in ("-w", "--words"):
        words=int(a)
    if o in ("-f", "--filter"):
        filtered=True
    if o in ("-s", "--summary"):
        summary=True
        names=False
        diff=False
        all=False
        edit=False
    if o in ("-c", "--comment"):
        comment=True
    if o in ("-u", "--upperlower"):
        upperlower=True
    if o in ("-b", "--blank"):
        blank=True
    if o in ("-p", "--punkt"):
        punkt=True
    if o in ("-d", "--dpunkt"):
        dpunkt=True
    if o in ("-l", "--levenstein"):
        levenstein=int(a)
    if o in ("-o", "--only"):
        only=True
    #if o in ("-k", "--klash"):
    #    klash=True
    if o in ("-g", "--globally"):
        globally=False
    if o in ("-n", "--names"):
        names=True
    if o in ("-t", "--translated"):
        translated=True
    if o in ("-e", "--entity"):
        entity=True
    if o in ("-k", "--markup"):
        markup=True
nargs=len(args)
if nargs < 1 or nargs > 2:
    usage()
else:
    if nargs==2:
        word_en=args[1]
    builddiff(os.path.abspath(args[0]), word_en)
